Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/Material/MaterialTypesMaster/FrmMaterialTypesMaster.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/Material/MaterialTypesMaster/FrmMaterialTypesMaster.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/Material/MaterialTypesMaster/FrmMaterialTypesMaster.cs	(revision 51)
@@ -0,0 +1,989 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Linq;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.DataEntry;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+//*------------------------ 単位マスタメンテ画面 ----------------------*
+//  2015/07/14  Ver1.0.0.0      Create Source           
+//
+//
+//
+//*----------------------------------------------------------------------------*
+namespace ProcessManagement.Forms.Master
+{
+    public partial class FrmMaterialTypesMaster : Form
+    {
+        #region 使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 表示カラム
+        /// </summary>
+        private enum DispColumn
+        {
+            RowState = 0,
+            DeleteFlg,
+            DisplayOrder,
+            MaterialTypesKey,
+            NameString,
+        }
+
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// フィールド値変化フラグ
+        /// </summary>
+        private bool m_bChengeAns = false;
+
+        /// <summary>
+        /// 初期時グリッドカウント
+        /// </summary>
+        private int m_initDataCount = 0;
+        /// <summary>
+        /// ダイアログ使用フラグ
+        /// </summary>
+        private bool m_DialogFlg = false;
+        /// <summary>
+        /// 単位文字
+        /// </summary>
+        private string m_UnitName = string.Empty;
+        /// <summary>
+        /// 単位キー
+        /// </summary>
+        private int m_UnitKey = 0;
+        /// <summary>
+        /// 終了ボタン押下フラグ
+        /// </summary>
+        private bool m_EndButton = false;
+        
+        /// <summary>
+        /// データ操作
+        /// </summary>
+        private IOMaterialTypes m_IoMt = null;
+
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        private bool m_EditLock = false;
+        #endregion
+
+        #region コンストラクタ
+        public FrmMaterialTypesMaster()
+        {
+            InitializeComponent();
+        }
+        #endregion
+        #region デストラクタ
+        ~FrmMaterialTypesMaster()
+        {
+            try
+            {
+                GC.Collect();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+
+        #region プロパティ
+        /// <summary>
+        /// ダイアログ使用時フラグ
+        /// </summary>
+        public bool DialogUsed
+        {
+            set { m_DialogFlg = value; }
+        }
+        /// <summary>
+        /// 単位文字取得
+        /// </summary>
+        public string UnitName
+        {
+            get { return m_UnitName; }
+        }
+        /// <summary>
+        /// 単位キー取得
+        /// </summary>
+        public int UnitKey
+        {
+            get { return m_UnitKey; }
+        }
+
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        public bool EditLock
+        {
+            get { return m_EditLock; }
+            set { m_EditLock = value; }
+        }
+        #endregion
+
+
+        #region イベントメソッド
+        /// <summary>
+        /// ×ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialTypesMaster_FormClosing(object sender, FormClosingEventArgs e)
+        {
+            try
+            {
+                if (m_EndButton) return;
+                if (m_bChengeAns)
+                {
+                    if (MessageBox.Show("データに変更があります、登録せずに終了してよろしいですか？。", "終了確認"
+                                    , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                    {
+                        e.Cancel = true;
+                        return;
+                    }
+                }
+
+                // 前プロセスに戻る
+                ClsExcute.BackProcess();
+            }
+            finally
+            {
+                // ロック解除用
+                if (e.Cancel != true && m_IoMt != null)
+                {
+                    m_IoMt.rollback();
+                    m_IoMt.close();
+                    m_IoMt = null;
+                }
+            }
+        }
+        /// <summary>
+        /// 終了ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            this.Close();
+        }
+
+        /// <summary>
+        /// フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialTypesMaster_Load(object sender, EventArgs e)
+        {
+            // 行削除押下時にロックを実行する為
+            try
+            {
+                m_IoMt = new IOMaterialTypes();
+                m_IoMt.connect();
+                m_IoMt.SetLockWaitime(1);
+                m_IoMt.beginTran();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                this.Close();
+            }
+
+            // 初期表示
+            InitDataLoad();
+
+            if (m_EditLock)
+            {
+                btnDataEntry.Enabled = false;
+                btnLineEntry.Enabled = false;
+                btnLineDelete.Enabled = false;
+            }
+
+            // ダイアログ使用時
+            if (m_DialogFlg)
+            {
+                //フォームの幅だけを変更する
+                this.SetBounds(this.Left, this.Top, (this.Width - 40), this.Height, BoundsSpecified.Width);
+            }
+            // フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+
+
+
+        }
+
+        /// <summary>
+        /// 行データクリア
+        /// </summary>
+        /// <param name="iIndex">行カウント</param>
+        private void SetRowClearData(int iIndex)
+        {            
+            // クリアデータセット
+            dgvMaster[(int)DispColumn.RowState, iIndex].Value = DataRowState.Unchanged;
+            dgvMaster[(int)DispColumn.DeleteFlg, iIndex].Value = "0";
+            dgvMaster[(int)DispColumn.DisplayOrder, iIndex].Value = "";
+            dgvMaster[(int)DispColumn.MaterialTypesKey, iIndex].Value = "";
+            dgvMaster[(int)DispColumn.NameString, iIndex].Value = "";
+        }
+
+        /// <summary>
+        /// グリッド採番処理
+        /// </summary>
+        private void LineReNumbering()
+        {
+            int icnt = 1;
+            foreach (DataGridViewRow r in dgvMaster.Rows)
+            {
+                // 表示されているものだけ採番
+                if (r.Visible)
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = (icnt++).ToString();
+            }
+        }
+        /// <summary>
+        /// 行追加ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnLineEntry_Click(object sender, EventArgs e)
+        {
+            // 行がない場合は作成して抜ける
+            if (dgvMaster.Rows.Count == 0)
+            {
+                if (MessageBox.Show("行を追加します", "追加確認"
+                                    , MessageBoxButtons.OKCancel, MessageBoxIcon.Information) == DialogResult.Cancel) return;
+
+                // 行追加
+                dgvMaster.Rows.Add();
+                // クリアデータセット
+                SetRowClearData(0);
+                // №再採番
+                LineReNumbering();
+                //　変更フラグOn
+                valueChange(sender, e);
+                // フォーカス移動
+                dgvMaster.Focus();
+                return;
+            }
+
+            // メッセージ表示
+            BtnTextCustomMessageBox msg = new BtnTextCustomMessageBox();
+            msg.ButtonText.No = "前へ追加";
+            msg.ButtonText.Yes = "後へ追加";
+            msg.ButtonText.Cancel = "キャンセル";
+            DialogResult resRet = msg.Show("行の前・後を選択してください。", "追加確認"
+                                            , MessageBoxButtons.YesNoCancel, MessageBoxIcon.Information);
+
+            // キャンセルは処理しない
+            if (resRet == DialogResult.Cancel) return;
+
+            // カレント行取得
+            int iIndex = dgvMaster.CurrentRow.Index;
+            // 最終行
+            if (iIndex == dgvMaster.RowCount - 1)
+            {
+                if (resRet == DialogResult.No)
+                {
+                    // 前
+                    dgvMaster.Rows.Insert(iIndex);
+                }
+                else if (resRet == DialogResult.Yes)
+                {
+                    // 後
+                    dgvMaster.Rows.Add();
+                    iIndex = (dgvMaster.RowCount - 1);
+                }
+            }
+            else
+            {
+                if (resRet == DialogResult.Yes)
+                {
+                    // 後ろ
+                    ++iIndex;
+                }
+                dgvMaster.Rows.Insert(iIndex);
+            }
+
+            // クリアデータセット
+            SetRowClearData(iIndex);
+
+            // №再採番
+            LineReNumbering();
+
+            //　変更フラグOn
+            valueChange(sender, e);
+
+            // フォーカス移動
+            dgvMaster.Focus();
+            //dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+            //dgvMaster.CurrentCell = dgvMaster[0, iIndex];
+        }
+
+        /// <summary>
+        /// フィールド値変更フラグ
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void valueChange(object sender, EventArgs e)
+        {
+            m_bChengeAns = true;
+            // セル更新
+            dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified; 
+
+        }
+
+        /// <summary>
+        /// セル値変化
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            // インデックス外は処理しない
+            if (e.RowIndex < 0 || e.ColumnIndex < 0) return;
+            // null値は処理しない
+            if (dgvMaster.Rows[e.RowIndex].Cells[e.ColumnIndex].Value == null) return;
+
+            // 値が変わればツールチップを変更する
+            dgvMaster.Rows[e.RowIndex].Cells[e.ColumnIndex].ToolTipText
+                = CommonMotions.cnvString(((DataGridView)sender).Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
+            // 変更フラグON
+            m_bChengeAns = true;
+            // セル更新
+            dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified; 
+
+        }
+        /// <summary>
+        /// 行削除ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnLineDelete_Click(object sender, EventArgs e)
+        {
+            IOMaterialItem miDB = new IOMaterialItem();
+
+            try
+            {
+                string kindCode = dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialTypesKey].Value.ToString();
+                if(kindCode!="")
+                { 
+                    if (CommonMotions.chkCellBlank(dgvMaster.CurrentRow.Cells[(int)DispColumn.NameString].Value)) return;
+
+                    // 資材品目確認
+                    int iItemCnt = miDB.SelectkindItemCount(int.Parse(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialTypesKey].Value.ToString()));
+                    if (iItemCnt > 0)
+                    {
+                        MessageBox.Show("資材品目が存在する資材種類の削除はできません。", "削除確認"
+                        , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    // 削除確認
+                    if (MessageBox.Show("選択した行データを削除します。", "削除確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return;
+
+                    // ロック 
+                    if (!m_IoMt.RowLock(int.Parse(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialTypesKey].Value.ToString()), false))
+                    {
+                        MessageBox.Show("他のユーザで編集中のため、処理できません。", "削除確認"
+                        , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    //削除実施
+                    string strSQL = m_IoMt.CreatePrimarykeyString(CommonMotions.cnvInt(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialTypesKey].Value));
+                    if (!m_IoMt.DeleteAction(strSQL, false))
+                    {
+                        m_IoMt.rollback();
+                        MessageBox.Show("削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+ 
+                    // 表示行退避
+                    int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                     // データ表示
+                    if (!DispGridData()) return;
+
+                    // 表示行復元
+                    dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+                }
+                else
+                {
+                    //今回追加したばかりの行についてはその場で削除
+                    // 削除確認
+                    if (MessageBox.Show("選択した行データを削除します。", "削除確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return;
+                    dgvMaster.Rows.RemoveAt(dgvMaster.CurrentRow.Index);
+                    LineReNumbering();
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                miDB = null;
+            }
+        }
+
+        /// <summary>
+        /// 登録ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDataEntry_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                //データチェック
+                if (!DispFeildCheck()) return;
+
+                if (MessageBox.Show("表示中のデータを登録します。", "登録確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
+
+                // 表示行退避
+                int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                // データ登録
+                MateriakTypesMasterDataEntry();
+
+                // データ表示
+                if (!DispGridData()) return;
+
+                // 表示行復元
+                dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+
+                // 変更フラグクリア
+                m_bChengeAns = false;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// IMEのコントロール
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellEnter(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = (DataGridView)sender;
+
+                if (dgv.CurrentCell.ReadOnly) return;
+
+                //列によってIMEのモードを変更する
+                if (dgv.Columns[e.ColumnIndex].Name.Equals("Column3"))
+                {
+                    dgv.ImeMode = ImeMode.On;
+                }
+                else
+                {
+                    dgv.ImeMode = ImeMode.Disable;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// アップキー押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDispUp_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 先頭は処理しない
+                if (dgvMaster.CurrentRow.Index == 0) return;
+
+                int irowcnt = dgvMaster.CurrentRow.Index;
+                if (irowcnt == 0) return;
+                if (CommonMotions.chkObjectIsNull(dgvMaster.Rows[irowcnt - 1].Cells[(int)DispColumn.NameString].Value)) return;
+
+                // グリッドアップキー処理
+                DataGridViewAction.GridRowUpAction((DataGridView)dgvMaster, (int)DispColumn.MaterialTypesKey, (int)DispColumn.NameString);
+
+                m_bChengeAns = true;
+                // セル更新
+                dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified; 
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        /// <summary>
+        /// ダウンキー押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDispDown_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 最終行は処理しない
+                if ((dgvMaster.CurrentRow.Index + 1) == dgvMaster.Rows.Count) return;
+
+
+                int irowcnt = dgvMaster.CurrentRow.Index;
+                if (CommonMotions.chkObjectIsNull(dgvMaster.Rows[irowcnt + 1].Cells[(int)DispColumn.NameString].Value)) return;
+                if (CommonMotions.cnvString(dgvMaster.Rows[irowcnt + 1].Cells[(int)DispColumn.NameString].Value).Length == 0) return;
+
+                // グリッドダウンキー処理
+                DataGridViewAction.GridRowDownAction((DataGridView)dgvMaster, (int)DispColumn.MaterialTypesKey, (int)DispColumn.NameString);
+
+                m_bChengeAns = true;
+                // セル更新
+                dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified; 
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// セルクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellClick(object sender, DataGridViewCellEventArgs e)
+        {
+            setButtonEnable();
+        }
+
+        /// <summary>
+        /// セルダブルクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
+        {
+            // ダイアログとして使用するとき以外は処理しない
+            if (!m_DialogFlg) return;
+
+            if (e.RowIndex < 0) return;
+
+            m_UnitKey = CommonMotions.cnvInt(((DataGridView)sender).Rows[e.RowIndex].Cells[(int)DispColumn.MaterialTypesKey].Value);
+            m_UnitName = CommonMotions.cnvString(((DataGridView)sender).Rows[e.RowIndex].Cells[(int)DispColumn.NameString].Value);
+            btnEnd_Click(sender, (EventArgs)e);
+        }
+
+        /// <summary>
+        /// Formキーダウン処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialTypesMaster_KeyDown(object sender, KeyEventArgs e)
+        {
+            // DataGridviewは処理しない
+            if (ActiveControl.Name.Equals("dgvMaster"))
+            {
+               
+                // 最終行時の処理
+                GridLastLine();
+                return;
+            }
+        }
+
+        #endregion
+
+        #region プライベートメソッド
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            try
+            {
+                // グリッドの行を0に戻す
+                dgvMaster.Rows.Clear();
+
+                if (!DispGridData()) return;
+
+                m_bChengeAns = false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bRet = true;
+            bool bAns = true;
+            string sErrmsg = "";
+            try
+            {
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+
+                    // 入力無は処理しない
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.MaterialTypesKey].Value).Length == 0
+                            && CommonMotions.chkObjectIsNull(r.Cells[(int)DispColumn.NameString].Value)) continue;
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.MaterialTypesKey].Value).Length == 0  
+                            && CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value).Length == 0) continue;
+
+                    // 削除行は処理しない
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.DeleteFlg].Value) == "1") continue;
+
+                    //名称
+                    bAns = true;
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value).Length == 0 )
+                    {
+                        bAns = false;
+                        sErrmsg = "資材種類の名称が入力されていません。";
+                    }
+                    else 
+                    {
+                        // レングスチェック
+                        bAns = CommonMotions.chkStringLength(CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value), 40);
+                        if (bAns == false)
+                        {
+                            sErrmsg = "入力エラーがあります、確認してください。";
+                        }
+                    }
+
+                    if (bAns)
+                    { 
+                        // 重複行調査
+                        DataGridViewRow[] rows = dgvMaster.Rows.Cast<DataGridViewRow>()
+                                                                    .Where(x =>x.Cells[(int)DispColumn.DeleteFlg].Value.ToString() == "0" && (string)x.Cells[(int)DispColumn.NameString].Value == (string)r.Cells[(int)DispColumn.NameString].Value).ToArray();
+                        if (rows.Count() > 1)
+                        {
+                            bAns = false;
+                            sErrmsg = "同一の資材種類が既に存在します。";
+                        }
+                    }
+                    // 背景色変更
+                    CommonMotions.chgBackColor(r.Cells[(int)DispColumn.NameString], bAns);
+                    bRet &= bAns;
+                }
+
+                if (!bRet)
+                {
+                    MessageBox.Show(sErrmsg, "データ確認"
+                                                , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                }
+
+                return bRet;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+
+        /// <summary>
+        /// マスタデータ登録
+        /// </summary>
+        private void MateriakTypesMasterDataEntry()
+        { 
+            try 
+            {
+                // 番号降り直し
+                int ino = 0;
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    // 入力無は処理しない
+                    if (CommonMotions.chkObjectIsNull(r.Cells[(int)DispColumn.NameString].Value)) continue;
+
+                    // 番号セット
+                    if (r.Cells[(int)DispColumn.DeleteFlg].Value.ToString() == "1")
+                        r.Cells[(int)DispColumn.DisplayOrder].Value = "999";
+                    else
+                        r.Cells[(int)DispColumn.DisplayOrder].Value = (++ino).ToString();
+                }
+
+                // データを画面より取得
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    // 入力無は処理しない
+                    if (CommonMotions.chkObjectIsNull(r.Cells[(int)DispColumn.NameString].Value)) continue;
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value).Length == 0) continue;
+
+                    // 更新無は処理しない
+                    //if ((DataRowState)r.Cells[(int)DispColumn.RowState].Value == DataRowState.Unchanged) continue;
+
+                    MaterialKindMaster uwork = new MaterialKindMaster();
+
+                    // データセット
+                    if (CommonMotions.chkCellBlank(r.Cells[(int)DispColumn.MaterialTypesKey].Value))
+                    {
+                        // 新規時キーセット
+                        // 履歴がない場合は過去の最大値をとる
+                        uwork.MaterialKindCode = m_IoMt.SelectMaxMaterialKindKeyCount(string.Empty, false) + 1;
+                    }
+                    else
+                    {
+                        uwork.MaterialKindCode = CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialTypesKey].Value);
+                    }
+                    uwork.MaterialKindName = CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value);
+                    uwork.DisplayOrder = CommonMotions.cnvInt(r.Cells[(int)DispColumn.DisplayOrder].Value);
+                    uwork.DeleteFlg = CommonMotions.cnvInt(r.Cells[(int)DispColumn.DeleteFlg].Value);
+
+                    // SQL作成
+                    string strSQL = m_IoMt.CreatePrimarykeyString(uwork.MaterialKindCode);
+                    List<MaterialKindMaster> mList = new List<MaterialKindMaster>();
+
+                    // 資材種類マスタ取得
+                    if (!m_IoMt.SelectAction(strSQL, ref mList, false))
+                    {
+                        m_IoMt.rollback();
+                        MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    if (mList.Count == 0)
+                    {
+                        // データがない場合は追加
+                        mList.Clear();
+                        mList.Add(uwork);
+
+                        // データ登録
+                        if (!m_IoMt.InsertAction(mList, false))
+                        {
+                            m_IoMt.rollback();
+                            MessageBox.Show("登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+                    }
+                    else
+                    {
+                        // 更新ロック
+                        if (!m_IoMt.RowLock(uwork.MaterialKindCode, false))
+                        {
+                            MessageBox.Show("他のユーザで編集中のため、処理できません。", "削除確認"
+                            , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+
+                        // データ登録
+                        if (!m_IoMt.UpdateAction(strSQL, uwork, false))
+                        {
+                            m_IoMt.rollback();
+                            MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+                    }
+                }
+
+                // 成功したらcommit
+                m_IoMt.commit();
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 資材種類登録表示
+        /// </summary>
+        /// <returns></returns>
+        private bool DispGridData()
+        {
+            List<MaterialKindMaster> cm = new List<MaterialKindMaster>();
+
+            try
+            {
+
+
+                    // グリッドの行を0に戻す
+                    dgvMaster.Rows.Clear();
+                    
+                    // SQL作成
+                    string strSQL = " Where DeleteFlg = 0 Order By DisplayOrder ASC"; 
+                    // 表示順マスタ取得
+                    if (!m_IoMt.SelectAction(strSQL, ref cm,false)) return false;
+
+                    // データ表示
+                    int icnt = 0;
+                    foreach (MaterialKindMaster work in cm)
+                    {
+                        dgvMaster.Rows.Add((icnt + 1)
+                                            , work.MaterialKindCode
+                                            , work.MaterialKindName.ToString());
+
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.RowState ].Value = DataRowState.Unchanged;
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.DeleteFlg].Value = work.DeleteFlg.ToString();
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialTypesKey].Value = work.MaterialKindCode.ToString();
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.NameString].Value = work.MaterialKindName;
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.NameString].ToolTipText = work.MaterialKindName;
+                        if (work.DeleteFlg == 1)
+                        {
+                            dgvMaster.Rows[icnt].Visible = false;
+                        }
+                        icnt++;
+                    }
+
+
+                // №再採番
+                LineReNumbering();
+
+                //// 表示行が足りない場合は追加する
+                //if (dgvMaster.Rows.Count <= CommonDefine.s_MaxInitLineCountMastamente)
+                //{
+                //    int iAddLine = CommonDefine.s_MaxInitLineCountMastamente - dgvMaster.Rows.Count;
+                //    for (int i = 0; i < iAddLine; i++)
+                //    {
+                //        dgvMaster.Rows.Add();
+                //    }
+                //}
+
+                    //dgvMaster.Rows.Add();
+                    // クリアデータセット
+                    //SetRowClearData(dgvMaster.Rows.Count - 1);
+
+                // 読込時データカウント取得
+                m_initDataCount = cm.Count;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                //cmDB.close();
+                //cmDB = null;
+            }
+            return true;
+        }
+
+        /// <summary>
+        /// ボタンの表示・非表示制御
+        /// </summary>
+        private void ButtonVisble(Control Parent)
+        {
+            bool bAns = true;
+            if (m_DialogFlg){
+
+                bAns = false;
+            }
+            else
+            {
+                bAns = true;
+            }
+
+            foreach (Control ctrl in Parent.Controls)
+            {
+                if (ctrl.GetType().Equals(typeof(Button)))
+                {
+                    // 終了ボタン以外を制御する
+                    if (ctrl.Name.ToString() != btnEnd.Name.ToString()) ctrl.Visible = bAns;
+                }
+            }
+            // グリッドの読込のみ制御
+            dgvMaster.ReadOnly = m_DialogFlg;
+        }
+
+        /// <summary>
+        /// グリッド最終行での処理
+        /// </summary>
+        private void GridLastLine()
+        {
+            // 最終行判定
+            if (dgvMaster.CurrentCell.RowIndex == dgvMaster.Rows.Count - 1)
+            {
+                // 最終列判定
+                if (dgvMaster.CurrentCell.ColumnIndex == (int)DispColumn.NameString)
+                {
+                    // 1行追加
+                    //dgvMaster.Rows.Add();
+                    // クリアデータセット
+                    //SetRowClearData(dgvMaster.Rows.Count - 1);
+                    // №再採番
+                    LineReNumbering();
+                }
+
+            }
+        }
+
+        /// <summary>
+        /// ボタン制御
+        /// </summary>
+        private void setButtonEnable()
+        {
+            try
+            {
+                // 一覧が選択されている場合、ボタンを活性にする
+                if (dgvMaster.SelectedCells.Count == 1)
+                {
+                    btnLineEntry.Enabled = true;
+                    btnLineDelete.Enabled = true;
+                    btnDispUp.Enabled = true;
+                    btnDispDown.Enabled = true;
+                }
+                // 一覧が選択されていない場合、ボタンを非活性にする
+                else
+                {
+                    btnLineEntry.Enabled = false;
+                    btnLineDelete.Enabled = false;
+                    btnDispUp.Enabled = false;
+                    btnDispDown.Enabled = false;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+
+        /// <summary>
+        /// PreviewKeyDownイベント
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
+        {
+            //複数選択時は削除させない
+            if (e.KeyCode == Keys.Delete && dgvMaster.SelectedCells.Count != 1)
+            {
+                dgvMaster.ClearSelection();
+            }
+        }
+
+        #endregion
+
+    }
+}
\ No newline at end of file
